'''
Created by Hyst v1.5
Hybrid Automaton in PySim
Converted from file: ./output/unsolved/stable/A5_diagonal_2__for_pysim__..spaceex.xml
Command Line arguments: -i ./output/unsolved/stable/A5_diagonal_2__for_pysim__..spaceex.xml -o ./output/unsolved/stable/A5_diagonal_2_pysim.py -tool pysim "-star True -corners True -rand 50 -xdim 1 -ydim 2"
'''

import math
import hybridpy.pysim.simulate as sim
from hybridpy.pysim.simulate import init_list_to_q_list, PySimSettings
from hybridpy.pysim.hybrid_automaton import HybridAutomaton, HyperRectangle

def define_ha():
    '''make the hybrid automaton and return it'''

    ha = HybridAutomaton()
    ha.variables = ["tau", "t", "x_p_1", "x_p_2", "y_sampled_1", "y_sampled_2", "x_d_1", "x_d_2", "u_1", "u_2", "Sample_y_1_pseudorandom_state", "Sample_y_2_pseudorandom_state", "Actuate_1_pseudorandom_state", "Actuate_2_pseudorandom_state"]


    wait_wait_wait_wait_always_tick_always_always = ha.new_mode('wait_wait_wait_wait_always_tick_always_always')
    wait_wait_wait_wait_always_tick_always_always.inv = lambda state: state[0] <= 0.4 and state[0] <= 0.4 and state[0] <= 0.1 and state[0] <= 0.1 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    wait_wait_wait_wait_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    wait_wait_wait_wait_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    wait_wait_wait_done_always_tick_always_always = ha.new_mode('wait_wait_wait_done_always_tick_always_always')
    wait_wait_wait_done_always_tick_always_always.inv = lambda state: state[0] <= 0.4 and state[0] <= 0.4 and state[0] <= 0.1 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    wait_wait_wait_done_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    wait_wait_wait_done_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    wait_wait_done_wait_always_tick_always_always = ha.new_mode('wait_wait_done_wait_always_tick_always_always')
    wait_wait_done_wait_always_tick_always_always.inv = lambda state: state[0] <= 0.4 and state[0] <= 0.4 and state[0] <= 0.1 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    wait_wait_done_wait_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    wait_wait_done_wait_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    wait_wait_done_done_always_tick_always_always = ha.new_mode('wait_wait_done_done_always_tick_always_always')
    wait_wait_done_done_always_tick_always_always.inv = lambda state: state[0] <= 0.4 and state[0] <= 0.4 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    wait_wait_done_done_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    wait_wait_done_done_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    wait_done_wait_wait_always_tick_always_always = ha.new_mode('wait_done_wait_wait_always_tick_always_always')
    wait_done_wait_wait_always_tick_always_always.inv = lambda state: state[0] <= 0.4 and state[0] <= 0.1 and state[0] <= 0.1 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    wait_done_wait_wait_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    wait_done_wait_wait_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    wait_done_wait_done_always_tick_always_always = ha.new_mode('wait_done_wait_done_always_tick_always_always')
    wait_done_wait_done_always_tick_always_always.inv = lambda state: state[0] <= 0.4 and state[0] <= 0.1 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    wait_done_wait_done_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    wait_done_wait_done_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    wait_done_done_wait_always_tick_always_always = ha.new_mode('wait_done_done_wait_always_tick_always_always')
    wait_done_done_wait_always_tick_always_always.inv = lambda state: state[0] <= 0.4 and state[0] <= 0.1 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    wait_done_done_wait_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    wait_done_done_wait_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    wait_done_done_done_always_tick_always_always = ha.new_mode('wait_done_done_done_always_tick_always_always')
    wait_done_done_done_always_tick_always_always.inv = lambda state: state[0] <= 0.4 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    wait_done_done_done_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    wait_done_done_done_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    done_wait_wait_wait_always_tick_always_always = ha.new_mode('done_wait_wait_wait_always_tick_always_always')
    done_wait_wait_wait_always_tick_always_always.inv = lambda state: state[0] <= 0.4 and state[0] <= 0.1 and state[0] <= 0.1 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    done_wait_wait_wait_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    done_wait_wait_wait_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    done_wait_wait_done_always_tick_always_always = ha.new_mode('done_wait_wait_done_always_tick_always_always')
    done_wait_wait_done_always_tick_always_always.inv = lambda state: state[0] <= 0.4 and state[0] <= 0.1 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    done_wait_wait_done_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    done_wait_wait_done_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    done_wait_done_wait_always_tick_always_always = ha.new_mode('done_wait_done_wait_always_tick_always_always')
    done_wait_done_wait_always_tick_always_always.inv = lambda state: state[0] <= 0.4 and state[0] <= 0.1 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    done_wait_done_wait_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    done_wait_done_wait_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    done_wait_done_done_always_tick_always_always = ha.new_mode('done_wait_done_done_always_tick_always_always')
    done_wait_done_done_always_tick_always_always.inv = lambda state: state[0] <= 0.4 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    done_wait_done_done_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    done_wait_done_done_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    done_done_wait_wait_always_tick_always_always = ha.new_mode('done_done_wait_wait_always_tick_always_always')
    done_done_wait_wait_always_tick_always_always.inv = lambda state: state[0] <= 0.1 and state[0] <= 0.1 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    done_done_wait_wait_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    done_done_wait_wait_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    done_done_wait_done_always_tick_always_always = ha.new_mode('done_done_wait_done_always_tick_always_always')
    done_done_wait_done_always_tick_always_always.inv = lambda state: state[0] <= 0.1 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    done_done_wait_done_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    done_done_wait_done_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    done_done_done_wait_always_tick_always_always = ha.new_mode('done_done_done_wait_always_tick_always_always')
    done_done_done_wait_always_tick_always_always.inv = lambda state: state[0] <= 0.1 and -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    done_done_done_wait_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    done_done_done_wait_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    done_done_done_done_always_tick_always_always = ha.new_mode('done_done_done_done_always_tick_always_always')
    done_done_done_done_always_tick_always_always.inv = lambda state: -1.0 / 2.0 <= state[0] and state[0] <= 1.0 / 2.0
    done_done_done_done_always_tick_always_always.der = lambda _, state: [1.0, 1.0, 0.05 * state[2] + 0.0 * state[3] + 0.5 * state[8] + 0.0 * state[9], 0.0 * state[2] + 0.05 * state[3] + 0.0 * state[8] + 0.5 * state[9], 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    done_done_done_done_always_tick_always_always.der_interval_list = [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]

    t = ha.new_transition(wait_wait_wait_wait_always_tick_always_always, done_wait_wait_wait_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[10] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, state[2] * 1.0 + state[3] * 0.0 + 0.0, None, None, None, None, None, None, None, None, None]

    t = ha.new_transition(wait_wait_wait_done_always_tick_always_always, done_wait_wait_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[10] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, state[2] * 1.0 + state[3] * 0.0 + 0.0, None, None, None, None, None, None, None, None, None]

    t = ha.new_transition(wait_wait_done_wait_always_tick_always_always, done_wait_done_wait_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[10] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, state[2] * 1.0 + state[3] * 0.0 + 0.0, None, None, None, None, None, None, None, None, None]

    t = ha.new_transition(wait_wait_done_done_always_tick_always_always, done_wait_done_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[10] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, state[2] * 1.0 + state[3] * 0.0 + 0.0, None, None, None, None, None, None, None, None, None]

    t = ha.new_transition(wait_done_wait_wait_always_tick_always_always, done_done_wait_wait_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[10] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, state[2] * 1.0 + state[3] * 0.0 + 0.0, None, None, None, None, None, None, None, None, None]

    t = ha.new_transition(wait_done_wait_done_always_tick_always_always, done_done_wait_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[10] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, state[2] * 1.0 + state[3] * 0.0 + 0.0, None, None, None, None, None, None, None, None, None]

    t = ha.new_transition(wait_done_done_wait_always_tick_always_always, done_done_done_wait_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[10] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, state[2] * 1.0 + state[3] * 0.0 + 0.0, None, None, None, None, None, None, None, None, None]

    t = ha.new_transition(wait_done_done_done_always_tick_always_always, done_done_done_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[10] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, state[2] * 1.0 + state[3] * 0.0 + 0.0, None, None, None, None, None, None, None, None, None]

    t = ha.new_transition(wait_wait_wait_wait_always_tick_always_always, wait_done_wait_wait_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[11] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, None, state[2] * 0.0 + state[3] * 1.0 + 0.0, None, None, None, None, None, None, None, None]

    t = ha.new_transition(wait_wait_wait_done_always_tick_always_always, wait_done_wait_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[11] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, None, state[2] * 0.0 + state[3] * 1.0 + 0.0, None, None, None, None, None, None, None, None]

    t = ha.new_transition(wait_wait_done_wait_always_tick_always_always, wait_done_done_wait_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[11] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, None, state[2] * 0.0 + state[3] * 1.0 + 0.0, None, None, None, None, None, None, None, None]

    t = ha.new_transition(wait_wait_done_done_always_tick_always_always, wait_done_done_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[11] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, None, state[2] * 0.0 + state[3] * 1.0 + 0.0, None, None, None, None, None, None, None, None]

    t = ha.new_transition(done_wait_wait_wait_always_tick_always_always, done_done_wait_wait_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[11] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, None, state[2] * 0.0 + state[3] * 1.0 + 0.0, None, None, None, None, None, None, None, None]

    t = ha.new_transition(done_wait_wait_done_always_tick_always_always, done_done_wait_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[11] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, None, state[2] * 0.0 + state[3] * 1.0 + 0.0, None, None, None, None, None, None, None, None]

    t = ha.new_transition(done_wait_done_wait_always_tick_always_always, done_done_done_wait_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[11] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, None, state[2] * 0.0 + state[3] * 1.0 + 0.0, None, None, None, None, None, None, None, None]

    t = ha.new_transition(done_wait_done_done_always_tick_always_always, done_done_done_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.1 + state[11] * (0.4 - -0.1)
    t.reset = lambda state: [None, None, None, None, None, state[2] * 0.0 + state[3] * 1.0 + 0.0, None, None, None, None, None, None, None, None]

    t = ha.new_transition(wait_wait_wait_wait_always_tick_always_always, wait_wait_done_wait_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[12] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, state[6] * 1.0 + state[7] * 0.0 + 0.0, None, None, None, None, None]

    t = ha.new_transition(wait_wait_wait_done_always_tick_always_always, wait_wait_done_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[12] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, state[6] * 1.0 + state[7] * 0.0 + 0.0, None, None, None, None, None]

    t = ha.new_transition(wait_done_wait_wait_always_tick_always_always, wait_done_done_wait_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[12] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, state[6] * 1.0 + state[7] * 0.0 + 0.0, None, None, None, None, None]

    t = ha.new_transition(wait_done_wait_done_always_tick_always_always, wait_done_done_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[12] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, state[6] * 1.0 + state[7] * 0.0 + 0.0, None, None, None, None, None]

    t = ha.new_transition(done_wait_wait_wait_always_tick_always_always, done_wait_done_wait_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[12] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, state[6] * 1.0 + state[7] * 0.0 + 0.0, None, None, None, None, None]

    t = ha.new_transition(done_wait_wait_done_always_tick_always_always, done_wait_done_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[12] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, state[6] * 1.0 + state[7] * 0.0 + 0.0, None, None, None, None, None]

    t = ha.new_transition(done_done_wait_wait_always_tick_always_always, done_done_done_wait_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[12] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, state[6] * 1.0 + state[7] * 0.0 + 0.0, None, None, None, None, None]

    t = ha.new_transition(done_done_wait_done_always_tick_always_always, done_done_done_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[12] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, state[6] * 1.0 + state[7] * 0.0 + 0.0, None, None, None, None, None]

    t = ha.new_transition(wait_wait_wait_wait_always_tick_always_always, wait_wait_wait_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[13] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, None, state[6] * 0.0 + state[7] * 1.0 + 0.0, None, None, None, None]

    t = ha.new_transition(wait_wait_done_wait_always_tick_always_always, wait_wait_done_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[13] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, None, state[6] * 0.0 + state[7] * 1.0 + 0.0, None, None, None, None]

    t = ha.new_transition(wait_done_wait_wait_always_tick_always_always, wait_done_wait_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[13] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, None, state[6] * 0.0 + state[7] * 1.0 + 0.0, None, None, None, None]

    t = ha.new_transition(wait_done_done_wait_always_tick_always_always, wait_done_done_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[13] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, None, state[6] * 0.0 + state[7] * 1.0 + 0.0, None, None, None, None]

    t = ha.new_transition(done_wait_wait_wait_always_tick_always_always, done_wait_wait_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[13] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, None, state[6] * 0.0 + state[7] * 1.0 + 0.0, None, None, None, None]

    t = ha.new_transition(done_wait_done_wait_always_tick_always_always, done_wait_done_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[13] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, None, state[6] * 0.0 + state[7] * 1.0 + 0.0, None, None, None, None]

    t = ha.new_transition(done_done_wait_wait_always_tick_always_always, done_done_wait_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[13] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, None, state[6] * 0.0 + state[7] * 1.0 + 0.0, None, None, None, None]

    t = ha.new_transition(done_done_done_wait_always_tick_always_always, done_done_done_done_always_tick_always_always)
    t.guard = lambda state: state[0] >= -0.4 + state[13] * (0.1 - -0.4)
    t.reset = lambda state: [None, None, None, None, None, None, None, None, None, state[6] * 0.0 + state[7] * 1.0 + 0.0, None, None, None, None]

    t = ha.new_transition(done_done_done_done_always_tick_always_always, wait_wait_wait_wait_always_tick_always_always)
    t.guard = lambda state: state[0] >= 1.0 / 2.0
    t.reset = lambda state: [-1.0 / 2.0, None, None, None, None, None, -0.4 * state[4] + -0.0 * state[5] + -0.01 * state[6] + -0.0 * state[7] + 0.0, -0.0 * state[4] + -0.4 * state[5] + -0.0 * state[6] + -0.01 * state[7] + 0.0, None, None, 0.5 + 0.5 * math.cos(1234.0 * state[10]), 0.5 + 0.5 * math.cos(1234.0 * state[11]), 0.5 + 0.5 * math.cos(1234.0 * state[12]), 0.5 + 0.5 * math.cos(1234.0 * state[13])]

    return ha

def define_init_states(ha):
    '''returns a list of (mode, HyperRectangle)'''
    # Variable ordering: [tau, t, x_p_1, x_p_2, y_sampled_1, y_sampled_2, x_d_1, x_d_2, u_1, u_2, Sample_y_1_pseudorandom_state, Sample_y_2_pseudorandom_state, Actuate_1_pseudorandom_state, Actuate_2_pseudorandom_state]
    rv = []
    
    rv.append((ha.modes['done_done_done_done_always_tick_always_always'],HyperRectangle([(0, 0), (0, 0), (-1, 1), (-1, 1), (0, 0), (0, 0), (0, 0), (0, 0), (0, 0), (0, 0), (0.5, 0.666333333333), (0.666333333333, 0.832666666667), (0, 0.166333333333), (0.166333333333, 0.332666666667)])))
    return rv


def define_settings():
    '''defines the automaton / plot settings'''
    s = PySimSettings()
    s.max_time = 25.0
    s.step = 0.001
    s.dim_x = 1
    s.dim_y = 2

    return s

def simulate(init_states, settings):
    '''simulate the automaton from each initial rect'''

    q_list = init_list_to_q_list(init_states, center=True, star=True, corners=True, rand=50)
    result = sim.simulate_multi(q_list, settings.max_time)

    return result

def plot(result, init_states, image_path, settings):
    '''plot a simulation result to a file'''

    draw_events = len(result) == 1
    shouldShow = False
    sim.plot_sim_result_multi(result, settings.dim_x, settings.dim_y, image_path, draw_events, legend=True, title='Simulation', show=shouldShow, init_states=init_states)

if __name__ == '__main__':
    ha = define_ha()
    settings = define_settings()
    init_states = define_init_states(ha)
    plot(simulate(init_states, settings), init_states, 'plot.png', settings)

